Index: /palm/trunk/SOURCE/land_surface_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 2269)
+++ /palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 2270)
@@ -467,131 +495,99 @@
                                    'fine        ',                  & ! 4
                                    'very fine   ',                  & ! 5
-                                   'organic     ',                  & ! 6
-                                   'loamy (CH)  '                   & ! 7
+                                   'organic     '                   & ! 6
                                                                  /)
-!
-!-- Land surface parameters according to the respective classes (veg_type)
-
-!
-!-- Land surface parameters I
-!--                          r_canopy_min,     lai,   c_veg,     g_d
-    REAL(wp), DIMENSION(0:3,1:20), PARAMETER :: veg_pars = RESHAPE( (/ &
-                                 180.0_wp, 3.00_wp, 0.90_wp, 0.00_wp,  & !  1
-                                 110.0_wp, 2.00_wp, 0.85_wp, 0.00_wp,  & !  2
-                                 500.0_wp, 5.00_wp, 0.90_wp, 0.03_wp,  & !  3
-                                 500.0_wp, 5.00_wp, 0.90_wp, 0.03_wp,  & !  4
-                                 175.0_wp, 5.00_wp, 0.90_wp, 0.03_wp,  & !  5
-                                 240.0_wp, 6.00_wp, 0.99_wp, 0.13_wp,  & !  6
-                                 100.0_wp, 2.00_wp, 0.70_wp, 0.00_wp,  & !  7
-                                 250.0_wp, 0.05_wp, 0.00_wp, 0.00_wp,  & !  8
-                                  80.0_wp, 1.00_wp, 0.50_wp, 0.00_wp,  & !  9
-                                 180.0_wp, 3.00_wp, 0.90_wp, 0.00_wp,  & ! 10
-                                 150.0_wp, 0.50_wp, 0.10_wp, 0.00_wp,  & ! 11
-                                   0.0_wp, 0.00_wp, 0.00_wp, 0.00_wp,  & ! 12
-                                 240.0_wp, 4.00_wp, 0.60_wp, 0.00_wp,  & ! 13
-                                   0.0_wp, 0.00_wp, 0.00_wp, 0.00_wp,  & ! 14
-                                   0.0_wp, 0.00_wp, 0.00_wp, 0.00_wp,  & ! 15
-                                 225.0_wp, 3.00_wp, 0.50_wp, 0.00_wp,  & ! 16
-                                 225.0_wp, 1.50_wp, 0.50_wp, 0.00_wp,  & ! 17
-                                 250.0_wp, 5.00_wp, 0.90_wp, 0.03_wp,  & ! 18
-                                 175.0_wp, 2.50_wp, 0.90_wp, 0.03_wp,  & ! 19
-                                   0.0_wp, 0.00_wp, 0.00_wp, 0.00_wp   & ! 20
-                                 /), (/ 4, 20 /) )
-
-!
-!-- Land surface parameters II          z0,         z0h,         z0q
-    REAL(wp), DIMENSION(0:2,1:20), PARAMETER :: roughness_par = RESHAPE( (/ & 
-                                   0.25_wp,  0.25E-2_wp,  0.25E-2_wp,       & !  1
-                                   0.20_wp,  0.20E-2_wp,  0.20E-2_wp,       & !  2
-                                   2.00_wp,     2.00_wp,     2.00_wp,       & !  3
-                                   2.00_wp,     2.00_wp,     2.00_wp,       & !  4
-                                   2.00_wp,     2.00_wp,     2.00_wp,       & !  5
-                                   2.00_wp,     2.00_wp,     2.00_wp,       & !  6
-                                   0.47_wp,  0.47E-2_wp,  0.47E-2_wp,       & !  7
-                                  0.013_wp, 0.013E-2_wp, 0.013E-2_wp,       & !  8
-                                  0.034_wp, 0.034E-2_wp, 0.034E-2_wp,       & !  9
-                                    0.5_wp,  0.50E-2_wp,  0.50E-2_wp,       & ! 10
-                                   0.17_wp,  0.17E-2_wp,  0.17E-2_wp,       & ! 11
-                                 1.3E-3_wp,   1.3E-4_wp,   1.3E-4_wp,       & ! 12
-                                   0.83_wp,  0.83E-2_wp,  0.83E-2_wp,       & ! 13
-                                   0.00_wp,     0.00_wp,     0.00_wp,       & ! 14
-                                   0.00_wp,     0.00_wp,     0.00_wp,       & ! 15
-                                   0.10_wp,  0.10E-2_wp,  0.10E-2_wp,       & ! 16
-                                   0.25_wp,  0.25E-2_wp,  0.25E-2_wp,       & ! 17
-                                   2.00_wp,     2.00_wp,     2.00_wp,       & ! 18
-                                   1.10_wp,     1.10_wp,     1.10_wp,       & ! 19
-                                 1.0E-4_wp,   1.0E-5_wp,   1.0E-5_wp        & ! 20
-                                 /), (/ 3, 20 /) )
-
-!
-!-- Land surface parameters III lambda_surface_s, lambda_surface_u, f_sw_in
-    REAL(wp), DIMENSION(0:2,1:20), PARAMETER :: surface_pars = RESHAPE( (/ &
-                                      10.0_wp,       10.0_wp, 0.05_wp,     & !  1
-                                      10.0_wp,       10.0_wp, 0.05_wp,     & !  2
-                                      20.0_wp,       15.0_wp, 0.03_wp,     & !  3
-                                      20.0_wp,       15.0_wp, 0.03_wp,     & !  4
-                                      20.0_wp,       15.0_wp, 0.03_wp,     & !  5
-                                      20.0_wp,       15.0_wp, 0.03_wp,     & !  6
-                                      10.0_wp,       10.0_wp, 0.05_wp,     & !  7
-                                      15.0_wp,       15.0_wp, 0.00_wp,     & !  8
-                                      10.0_wp,       10.0_wp, 0.05_wp,     & !  9
-                                      10.0_wp,       10.0_wp, 0.05_wp,     & ! 10 
-                                      10.0_wp,       10.0_wp, 0.05_wp,     & ! 11
-                                      58.0_wp,       58.0_wp, 0.00_wp,     & ! 12
-                                      10.0_wp,       10.0_wp, 0.05_wp,     & ! 13 
-                                    1.0E10_wp,     1.0E10_wp, 0.00_wp,     & ! 14
-                                    1.0E10_wp,     1.0E10_wp, 0.00_wp,     & ! 15
-                                      10.0_wp,       10.0_wp, 0.05_wp,     & ! 16
-                                      10.0_wp,       10.0_wp, 0.05_wp,     & ! 17
-                                      20.0_wp,       15.0_wp, 0.03_wp,     & ! 18
-                                      20.0_wp,       15.0_wp, 0.03_wp,     & ! 19
-                                       0.0_wp,        0.0_wp, 0.00_wp      & ! 20
-                                      /), (/ 3, 20 /) )
-
-!
-!-- Root distribution (sum = 1)  level 1-8
-!--                               
-    REAL(wp), DIMENSION(0:7,1:20), PARAMETER :: root_distribution = RESHAPE( (/&
+
+!
+!-- Pavement classes
+    CHARACTER(20), DIMENSION(0:7), PARAMETER :: pavement_type_name = (/ &
+                                   'user defined        ',          & ! 0 
+                                   'asphalt             ',          & ! 1
+                                   'concrete            ',          & ! 2
+                                   'asphalt/concrete mix',          & ! 3
+                                   'brick pavers        ',          & ! 4
+                                   'cobblestone pavers  ',          & ! 5
+                                   'sett pavers         ',          & ! 6
+                                   'gravel pavers       '           & ! 7
+                                                                 /)                                                                 
+                                                                 
+!
+!-- Water classes
+    CHARACTER(12), DIMENSION(0:4), PARAMETER :: water_type_name = (/ &
+                                   'user defined',                   & ! 0 
+                                   'lake        ',                   & ! 1
+                                   'river       ',                   & ! 2
+                                   'ocean       ',                   & ! 3
+                                   'pond        '                    & ! 4
+                                                                  /)                                                                  
+                                                                 
+                                                                 !
+!-- Land surface parameters according to the respective classes (vegetation_type)
+
+!
+!-- Land surface parameters
+!-- r_canopy_min,     lai,   c_veg,     g_d         z0,         z0h, lambda_s_s, lambda_s_u, f_sw_in,  c_surface
+    REAL(wp), DIMENSION(0:9,1:18), PARAMETER :: vegetation_pars = RESHAPE( (/ &
+          0.0_wp, 0.00_wp, 0.00_wp, 0.00_wp, 0.5E-2_wp,   0.5E-4_wp,     0.0_wp,     0.0_wp, 0.00_wp, 0.00_wp, & !  1
+        180.0_wp, 3.00_wp, 0.90_wp, 0.00_wp,   0.25_wp,  0.25E-2_wp,   140.0_wp,   140.0_wp, 0.05_wp, 0.00_wp, & !  2
+        110.0_wp, 2.00_wp, 0.85_wp, 0.00_wp,   0.20_wp,  0.20E-2_wp,   140.0_wp,   140.0_wp, 0.05_wp, 0.00_wp, & !  3
+        500.0_wp, 5.00_wp, 0.90_wp, 0.03_wp,   2.00_wp,     2.00_wp,   280.0_wp,   196.0_wp, 0.03_wp, 0.00_wp, & !  4
+        500.0_wp, 5.00_wp, 0.90_wp, 0.03_wp,   2.00_wp,     2.00_wp,   280.0_wp,   196.0_wp, 0.03_wp, 0.00_wp, & !  5
+        175.0_wp, 5.00_wp, 0.90_wp, 0.03_wp,   2.00_wp,     2.00_wp,   280.0_wp,   196.0_wp, 0.03_wp, 0.00_wp, & !  6
+        240.0_wp, 6.00_wp, 0.99_wp, 0.13_wp,   2.00_wp,     2.00_wp,   280.0_wp,   196.0_wp, 0.03_wp, 0.00_wp, & !  7
+        100.0_wp, 2.00_wp, 0.70_wp, 0.00_wp,   0.47_wp,  0.47E-2_wp,   140.0_wp,   140.0_wp, 0.05_wp, 0.00_wp, & !  8
+        250.0_wp, 0.05_wp, 0.00_wp, 0.00_wp,  0.013_wp, 0.013E-2_wp,   196.0_wp,   196.0_wp, 0.00_wp, 0.00_wp, & !  9
+         80.0_wp, 1.00_wp, 0.50_wp, 0.00_wp,  0.034_wp, 0.034E-2_wp,   140.0_wp,   140.0_wp, 0.05_wp, 0.00_wp, & ! 10
+        180.0_wp, 3.00_wp, 0.90_wp, 0.00_wp,    0.5_wp,  0.50E-2_wp,   140.0_wp,   140.0_wp, 0.05_wp, 0.00_wp, & ! 11
+        150.0_wp, 0.50_wp, 0.10_wp, 0.00_wp,   0.17_wp,  0.17E-2_wp,   140.0_wp,   140.0_wp, 0.05_wp, 0.00_wp, & ! 12
+          0.0_wp, 0.00_wp, 0.00_wp, 0.00_wp, 1.3E-3_wp,   1.3E-4_wp,   812.0_wp,   812.0_wp, 0.00_wp, 0.00_wp, & ! 13
+        240.0_wp, 4.00_wp, 0.60_wp, 0.00_wp,   0.83_wp,  0.83E-2_wp,   140.0_wp,   140.0_wp, 0.05_wp, 0.00_wp, & ! 14
+        225.0_wp, 3.00_wp, 0.50_wp, 0.00_wp,   0.10_wp,  0.10E-2_wp,   140.0_wp,   140.0_wp, 0.05_wp, 0.00_wp, & ! 15
+        225.0_wp, 1.50_wp, 0.50_wp, 0.00_wp,   0.25_wp,  0.25E-2_wp,   140.0_wp,   140.0_wp, 0.05_wp, 0.00_wp, & ! 16
+        250.0_wp, 5.00_wp, 0.90_wp, 0.03_wp,   2.00_wp,     2.00_wp,   280.0_wp,   196.0_wp, 0.03_wp, 0.00_wp, & ! 17
+        175.0_wp, 2.50_wp, 0.90_wp, 0.03_wp,   1.10_wp,     1.10_wp,   280.0_wp,   196.0_wp, 0.03_wp, 0.00_wp  & ! 18
+                                                               /), (/ 10, 18 /) )
+
+                                    
+!
+!-- Root distribution for default soil layer configuration (sum = 1)
+!--                                level 1 - level 8
+    REAL(wp), DIMENSION(0:7,1:18), PARAMETER :: root_distribution = RESHAPE( (/&
+                                   1.000_wp, 0.000_wp, 0.000_wp, 0.000_wp,     &
+                                   0.000_wp, 0.000_wp, 0.000_wp, 0.000_wp,     & ! 1
                                    0.035_wp, 0.069_wp, 0.069_wp, 0.108_wp,     &
-                                   0.195_wp, 0.214_wp, 0.284_wp, 0.026_wp,     & ! 1
+                                   0.195_wp, 0.214_wp, 0.284_wp, 0.026_wp,     & ! 2
                                    0.050_wp, 0.100_wp, 0.100_wp, 0.136_wp,     &
-                                   0.181_wp, 0.192_wp, 0.215_wp, 0.026_wp,     & ! 2
+                                   0.181_wp, 0.192_wp, 0.215_wp, 0.026_wp,     & ! 3
                                    0.038_wp, 0.075_wp, 0.075_wp, 0.111_wp,     &
-                                   0.185_wp, 0.203_wp, 0.273_wp, 0.040_wp,     & ! 3
+                                   0.185_wp, 0.203_wp, 0.273_wp, 0.040_wp,     & ! 4
                                    0.038_wp, 0.075_wp, 0.075_wp, 0.110_wp,     &
-                                   0.180_wp, 0.199_wp, 0.277_wp, 0.046_wp,     & ! 4
+                                   0.180_wp, 0.199_wp, 0.277_wp, 0.046_wp,     & ! 5
                                    0.035_wp, 0.069_wp, 0.069_wp, 0.105_wp,     &
-                                   0.180_wp, 0.201_wp, 0.295_wp, 0.046_wp,     & ! 5
+                                   0.180_wp, 0.201_wp, 0.295_wp, 0.046_wp,     & ! 6
                                    0.035_wp, 0.072_wp, 0.072_wp, 0.105_wp,     &
-                                   0.161_wp, 0.180_wp, 0.282_wp, 0.093_wp,     & ! 6
+                                   0.161_wp, 0.180_wp, 0.282_wp, 0.093_wp,     & ! 7
                                    0.040_wp, 0.077_wp, 0.077_wp, 0.112_wp,     &
-                                   0.176_wp, 0.192_wp, 0.266_wp, 0.060_wp,     & ! 7
+                                   0.176_wp, 0.192_wp, 0.266_wp, 0.060_wp,     & ! 8
                                    0.142_wp, 0.286_wp, 0.286_wp, 0.286_wp,     &
-                                   0.000_wp, 0.000_wp, 0.000_wp, 0.000_wp,     & ! 8
+                                   0.000_wp, 0.000_wp, 0.000_wp, 0.000_wp,     & ! 9
                                    0.068_wp, 0.134_wp, 0.134_wp, 0.177_wp,     &
-                                   0.214_wp, 0.203_wp, 0.070_wp, 0.000_wp,     & ! 9
+                                   0.214_wp, 0.203_wp, 0.070_wp, 0.000_wp,     & ! 10
                                    0.035_wp, 0.068_wp, 0.068_wp, 0.108_wp,     &
-                                   0.195_wp, 0.215_wp, 0.285_wp, 0.026_wp,     & ! 10
+                                   0.195_wp, 0.215_wp, 0.285_wp, 0.026_wp,     & ! 11
                                    0.025_wp, 0.048_wp, 0.048_wp, 0.078_wp,     &
-                                   0.147_wp, 0.175_wp, 0.353_wp, 0.126_wp,     & ! 11
+                                   0.147_wp, 0.175_wp, 0.353_wp, 0.126_wp,     & ! 12
                                    0.000_wp, 0.000_wp, 0.000_wp, 0.000_wp,     &
-                                   0.000_wp, 0.000_wp, 0.000_wp, 0.000_wp,     & ! 12
+                                   0.000_wp, 0.000_wp, 0.000_wp, 0.000_wp,     & ! 13
                                    0.036_wp, 0.072_wp, 0.072_wp, 0.103_wp,     &
-                                   0.163_wp, 0.180_wp, 0.273_wp, 0.074_wp,     & ! 13
-                                   0.000_wp, 0.000_wp, 0.000_wp, 0.000_wp,     &
-                                   0.000_wp, 0.000_wp, 0.000_wp, 0.000_wp,     & ! 14
-                                   0.000_wp, 0.000_wp, 0.000_wp, 0.000_wp,     &
-                                   0.000_wp, 0.000_wp, 0.000_wp, 0.000_wp,     & ! 15
+                                   0.163_wp, 0.180_wp, 0.273_wp, 0.074_wp,     & ! 14
+                                   0.032_wp, 0.066_wp, 0.066_wp, 0.100_wp,     &
+                                   0.172_wp, 0.192_wp, 0.299_wp, 0.073_wp,     & ! 15
                                    0.032_wp, 0.066_wp, 0.066_wp, 0.100_wp,     &
                                    0.172_wp, 0.192_wp, 0.299_wp, 0.073_wp,     & ! 16
-                                   0.032_wp, 0.066_wp, 0.066_wp, 0.100_wp,     &
-                                   0.172_wp, 0.192_wp, 0.299_wp, 0.073_wp,     & ! 17
                                    0.028_wp, 0.055_wp, 0.055_wp, 0.087_wp,     &
-                                   0.166_wp, 0.195_wp, 0.348_wp, 0.066_wp,     & ! 18
+                                   0.166_wp, 0.195_wp, 0.348_wp, 0.066_wp,     & ! 17
                                    0.028_wp, 0.055_wp, 0.055_wp, 0.087_wp,     &
-                                   0.166_wp, 0.195_wp, 0.348_wp, 0.066_wp,     & ! 19
-                                   0.000_wp, 0.000_wp, 0.000_wp, 0.000_wp,     &
-                                   0.000_wp, 0.000_wp, 0.000_wp, 0.000_wp      & ! 20
-                                 /), (/ 8, 20 /) )
+                                   0.166_wp, 0.195_wp, 0.348_wp, 0.066_wp      & ! 18
+                                 /), (/ 8, 18 /) )
 
 
@@ -600,28 +596,37 @@
 
 !
-!-- Soil parameters I           alpha_vg,      l_vg,    n_vg, gamma_w_sat
-    REAL(wp), DIMENSION(0:3,1:7), PARAMETER :: soil_pars = RESHAPE( (/     &
-                                 3.83_wp,  1.250_wp, 1.38_wp,  6.94E-6_wp, & ! 1
-                                 3.14_wp, -2.342_wp, 1.28_wp,  1.16E-6_wp, & ! 2
-                                 0.83_wp, -0.588_wp, 1.25_wp,  0.26E-6_wp, & ! 3
-                                 3.67_wp, -1.977_wp, 1.10_wp,  2.87E-6_wp, & ! 4
-                                 2.65_wp,  2.500_wp, 1.10_wp,  1.74E-6_wp, & ! 5
-                                 1.30_wp,  0.400_wp, 1.20_wp,  0.93E-6_wp, & ! 6
-                                 0.00_wp,  0.00_wp,  0.00_wp,  0.57E-6_wp  & ! 7
-                                 /), (/ 4, 7 /) )
-
-!
-!-- Soil parameters II              m_sat,     m_fc,   m_wilt,    m_res  
-    REAL(wp), DIMENSION(0:3,1:7), PARAMETER :: m_soil_pars = RESHAPE( (/ &
-                                 0.403_wp, 0.244_wp, 0.059_wp, 0.025_wp, & ! 1
-                                 0.439_wp, 0.347_wp, 0.151_wp, 0.010_wp, & ! 2
-                                 0.430_wp, 0.383_wp, 0.133_wp, 0.010_wp, & ! 3
-                                 0.520_wp, 0.448_wp, 0.279_wp, 0.010_wp, & ! 4
-                                 0.614_wp, 0.541_wp, 0.335_wp, 0.010_wp, & ! 5
-                                 0.766_wp, 0.663_wp, 0.267_wp, 0.010_wp, & ! 6
-                                 0.472_wp, 0.323_wp, 0.171_wp, 0.000_wp  & ! 7
-                                 /), (/ 4, 7 /) )
-
-
+!-- Soil parameters             alpha_vg,      l_vg,    n_vg, gamma_w_sat,    m_sat,     m_fc,   m_wilt,    m_res 
+    REAL(wp), DIMENSION(0:7,1:6), PARAMETER :: soil_pars = RESHAPE( (/     &
+                                 3.83_wp,  1.250_wp, 1.38_wp,  6.94E-6_wp, 0.403_wp, 0.244_wp, 0.059_wp, 0.025_wp,& ! 1
+                                 3.14_wp, -2.342_wp, 1.28_wp,  1.16E-6_wp, 0.439_wp, 0.347_wp, 0.151_wp, 0.010_wp,& ! 2
+                                 0.83_wp, -0.588_wp, 1.25_wp,  0.26E-6_wp, 0.430_wp, 0.383_wp, 0.133_wp, 0.010_wp,& ! 3
+                                 3.67_wp, -1.977_wp, 1.10_wp,  2.87E-6_wp, 0.520_wp, 0.448_wp, 0.279_wp, 0.010_wp,& ! 4
+                                 2.65_wp,  2.500_wp, 1.10_wp,  1.74E-6_wp, 0.614_wp, 0.541_wp, 0.335_wp, 0.010_wp,& ! 5
+                                 1.30_wp,  0.400_wp, 1.20_wp,  0.93E-6_wp, 0.766_wp, 0.663_wp, 0.267_wp, 0.010_wp & ! 6
+                                 /), (/ 8, 6 /) )
+
+!
+!-- TO BE FILLED
+!-- Pavement parameters  depth,        z0,       z0h, lambda_h,      rho_c  
+    REAL(wp), DIMENSION(0:4,1:7), PARAMETER :: pavement_pars = RESHAPE( (/ &
+                      0.050_wp, 1.0E-4_wp, 1.0E-5_wp,  1.00_wp,  1.94E6_wp, & ! 1
+                      0.050_wp, 1.0E-4_wp, 1.0E-5_wp,  1.00_wp,  1.94E6_wp, & ! 2
+                      0.050_wp, 1.0E-4_wp, 1.0E-5_wp,  1.00_wp,  1.94E6_wp, & ! 3                                  
+                      0.050_wp, 1.0E-4_wp, 1.0E-5_wp,  1.00_wp,  1.94E6_wp, & ! 4
+                      0.050_wp, 1.0E-4_wp, 1.0E-5_wp,  1.00_wp,  1.94E6_wp, & ! 5
+                      0.050_wp, 1.0E-4_wp, 1.0E-5_wp,  1.00_wp,  1.94E6_wp, & ! 6
+                      0.050_wp, 1.0E-4_wp, 1.0E-5_wp,  1.00_wp,  1.94E6_wp  & ! 7
+                                                                 /), (/ 5, 7 /) )                             
+
+!
+!-- TO BE FILLED
+!-- Water parameters                    temperature,     z0,      z0h
+    REAL(wp), DIMENSION(0:2,1:4), PARAMETER :: water_pars = RESHAPE( (/ &
+                                           283.0_wp, 0.01_wp, 0.001_wp, & ! 1
+                                           283.0_wp, 0.01_wp, 0.001_wp, & ! 2
+                                           283.0_wp, 0.01_wp, 0.001_wp, & ! 3
+                                           283.0_wp, 10.01_wp, 0.001_wp & ! 4
+                                                                /), (/ 3, 4 /) )                                                                     
+                                                                                                                                      
     SAVE
 
@@ -637,5 +642,5 @@
            lsm_header, lsm_init, lsm_init_arrays, lsm_parin, lsm_soil_model,   &
            lsm_swap_timelevel, lsm_read_restart_data, lsm_last_actions
-!
+! !vegetat
 !-- Public parameters, constants and initial values
     PUBLIC aero_resist_kray, skip_time_do_lsm
@@ -754,7 +759,7 @@
           unit = 'K'   
              
-       CASE ( 'lai*', 'c_liq*', 'c_soil*', 'c_veg*', 'ghf_eb*', 'm_liq_eb*',&
-              'qsws_eb*', 'qsws_liq_eb*', 'qsws_soil_eb*', 'qsws_veg_eb*',  &
-              'r_a*', 'r_s*', 'shf_eb*' )
+       CASE ( 'lai*', 'c_liq*', 'c_soil*', 'c_veg*', 'ghf*', 'm_liq*',&
+              'qsws_liq*', 'qsws_soil*', 'qsws_veg*',  &
+              'r_a*', 'r_s*' )
           IF ( k == 0  .OR.  data_output(i)(ilen-2:ilen) /= '_xy' )  THEN
              message_string = 'illegal value for data_output: "' //         &
@@ -783,20 +788,15 @@
              CALL message( 'check_parameters', 'PA0401', 1, 2, 0, 6, 0 )
           ENDIF
-          IF ( TRIM( var ) == 'ghf_eb*'  .AND.  .NOT.  land_surface )  THEN
+          IF ( TRIM( var ) == 'ghf*'  .AND.  .NOT.  land_surface )  THEN
              message_string = 'output of "' // TRIM( var ) // '" requi' //  &
                               'res land_surface = .TRUE.'
              CALL message( 'check_parameters', 'PA0404', 1, 2, 0, 6, 0 )
           ENDIF
-          IF ( TRIM( var ) == 'm_liq_eb*'  .AND.  .NOT.  land_surface )  THEN
+          IF ( TRIM( var ) == 'm_liq*'  .AND.  .NOT.  land_surface )  THEN
              message_string = 'output of "' // TRIM( var ) // '" requi' //  &
                               'res land_surface = .TRUE.'
              CALL message( 'check_parameters', 'PA0404', 1, 2, 0, 6, 0 )
           ENDIF
-          IF ( TRIM( var ) == 'qsws_eb*'  .AND.  .NOT.  land_surface )  THEN
-             message_string = 'output of "' // TRIM( var ) // '" requi' //  &
-                              'res land_surface = .TRUE.'
-             CALL message( 'check_parameters', 'PA0404', 1, 2, 0, 6, 0 )
-          ENDIF
-          IF ( TRIM( var ) == 'qsws_liq_eb*'  .AND.  .NOT. land_surface )   &
+          IF ( TRIM( var ) == 'qsws_liq*'  .AND.  .NOT. land_surface )   &
           THEN
              message_string = 'output of "' // TRIM( var ) // '" requi' //  &
@@ -804,5 +804,5 @@
              CALL message( 'check_parameters', 'PA0404', 1, 2, 0, 6, 0 )
           ENDIF
-          IF ( TRIM( var ) == 'qsws_soil_eb*'  .AND.  .NOT.  land_surface ) &
+          IF ( TRIM( var ) == 'qsws_soil*'  .AND.  .NOT.  land_surface ) &
           THEN
              message_string = 'output of "' // TRIM( var ) // '" requi' //  &
@@ -810,5 +810,5 @@
              CALL message( 'check_parameters', 'PA0404', 1, 2, 0, 6, 0 )
           ENDIF
-          IF ( TRIM( var ) == 'qsws_veg_eb*'  .AND.  .NOT. land_surface )   &
+          IF ( TRIM( var ) == 'qsws_veg*'  .AND.  .NOT. land_surface )   &
           THEN
              message_string = 'output of "' // TRIM( var ) // '" requi' //  &
@@ -833,13 +833,11 @@
           IF ( TRIM( var ) == 'c_soil*')  unit = 'none'
           IF ( TRIM( var ) == 'c_veg*' )  unit = 'none'
-          IF ( TRIM( var ) == 'ghf_eb*')  unit = 'W/m2'
-          IF ( TRIM( var ) == 'm_liq_eb*'     )  unit = 'm'
-          IF ( TRIM( var ) == 'qsws_eb*'      ) unit = 'W/m2'
-          IF ( TRIM( var ) == 'qsws_liq_eb*'  ) unit = 'W/m2'
-          IF ( TRIM( var ) == 'qsws_soil_eb*' ) unit = 'W/m2'
-          IF ( TRIM( var ) == 'qsws_veg_eb*'  ) unit = 'W/m2'
+          IF ( TRIM( var ) == 'ghf*')  unit = 'W/m2'
+          IF ( TRIM( var ) == 'm_liq*'     )  unit = 'm'
+          IF ( TRIM( var ) == 'qsws_liq*'  ) unit = 'W/m2'
+          IF ( TRIM( var ) == 'qsws_soil*' ) unit = 'W/m2'
+          IF ( TRIM( var ) == 'qsws_veg*'  ) unit = 'W/m2'
           IF ( TRIM( var ) == 'r_a*')     unit = 's/m'     
           IF ( TRIM( var ) == 'r_s*')     unit = 's/m' 
-          IF ( TRIM( var ) == 'shf_eb*')  unit = 'W/m2'
              
        CASE DEFAULT
@@ -888,8 +886,8 @@
              dopr_index(var_count) = 89
              dopr_unit     = 'K'
-             hom(0:nzs-1,2,89,:)  = SPREAD( - zs, 2, statistic_regions+1 )
+             hom(0:nzs-1,2,89,:)  = SPREAD( - zs(nzb_soil:nzt_soil), 2, statistic_regions+1 )
              IF ( data_output_pr(var_count)(1:1) == '#' )  THEN
                 dopr_initial_index(var_count) = 90
-                hom(0:nzs-1,2,90,:)   = SPREAD( - zs, 2, statistic_regions+1 )
+                hom(0:nzs-1,2,90,:)   = SPREAD( - zs(nzb_soil:nzt_soil), 2, statistic_regions+1 )
                 data_output_pr(var_count)     = data_output_pr(var_count)(2:)
              ENDIF
@@ -906,8 +904,8 @@
              dopr_index(var_count) = 91
              dopr_unit     = 'm3/m3'
-             hom(0:nzs-1,2,91,:)  = SPREAD( - zs, 2, statistic_regions+1 )
+             hom(0:nzs-1,2,91,:)  = SPREAD( - zs(nzb_soil:nzt_soil), 2, statistic_regions+1 )
              IF ( data_output_pr(var_count)(1:1) == '#' )  THEN
                 dopr_initial_index(var_count) = 92
-                hom(0:nzs-1,2,92,:)   = SPREAD( - zs, 2, statistic_regions+1 )
+                hom(0:nzs-1,2,92,:)   = SPREAD( - zs(nzb_soil:nzt_soil), 2, statistic_regions+1 )
                 data_output_pr(var_count)     = data_output_pr(var_count)(2:)
              ENDIF
@@ -943,4 +941,17 @@
 
     INTEGER(iwp) ::  k        !< running index, z-dimension
+
+!
+!-- Check for a valid setting of surface_type. The default value is 'netcdf'.
+!-- In that case, the surface types are read from NetCDF file
+    IF ( TRIM( surface_type ) /= 'vegetation'  .AND.                           &
+         TRIM( surface_type ) /= 'pavement'    .AND.                           &
+         TRIM( surface_type ) /= 'water'       .AND.                           &
+         TRIM( surface_type ) /= 'netcdf' )  THEN  
+          message_string = 'unknown surface type surface_type = "' //     &
+                        TRIM( surface_type ) // '"'
+                CALL message( 'check_parameters', 'PA0019', 1, 2, 0, 6, 0 )
+    ENDIF
+
 !
 !-- Dirichlet boundary conditions are required as the surface fluxes are
@@ -948,6 +959,6 @@
 !-- model
     IF ( bc_pt_b == 'neumann'  .OR.  bc_q_b == 'neumann' )  THEN
-       message_string = 'lsm requires setting of'//                         &
-                        'bc_pt_b = "dirichlet" and '//                      &
+       message_string = 'lsm requires setting of'//                            &
+                        'bc_pt_b = "dirichlet" and '//                         &
                         'bc_q_b  = "dirichlet"'
        CALL message( 'check_parameters', 'PA0399', 1, 2, 0, 6, 0 )
